//
//  HFFluidGlassStyleKit.swift
//  HealthAndFood
//
//  Created by dzmitry.antonenka on 4/2/17.
//  Copyright © 2017 BSUIR. All rights reserved.
//
//  Generated by PaintCode
//  http://www.paintcodeapp.com
//



import UIKit

public class HFFluidGlassStyleKit : NSObject {

    //// Drawing Methods

    @objc public dynamic class func drawGlassOfFluid(frame: CGRect = CGRect(x: 5, y: 66, width: 27, height: 73), lineWidth: CGFloat = 1, glassTopWidth: CGFloat = 1, glassOuterBottomWidth: CGFloat = 1) {
        //// General Declarations
        let context = UIGraphicsGetCurrentContext()!
        // This non-generic function dramatically improves compilation times of complex expressions.
        func fastFloor(_ x: CGFloat) -> CGFloat { return floor(x) }

        //// Color Declarations
        let fluidFillolor = UIColor(red: 0.271, green: 0.824, blue: 0.282, alpha: 1.000)

        //// Shadow Declarations
        let helpShadowOvalShadow = NSShadow()
        helpShadowOvalShadow.shadowColor = UIColor.black.withAlphaComponent(0.24)
        helpShadowOvalShadow.shadowOffset = CGSize(width: 0, height: 32)
        helpShadowOvalShadow.shadowBlurRadius = 2
        let shadow = NSShadow()
        shadow.shadowColor = UIColor.black.withAlphaComponent(0.48)
        shadow.shadowOffset = CGSize(width: 0, height: 32)
        shadow.shadowBlurRadius = 5


        //// Subframes
        let glass: CGRect = CGRect(x: frame.minX + fastFloor(frame.width * 0.01686 + 0.04) + 0.46, y: frame.minY + fastFloor(frame.height * 0.00685) + 0.5, width: fastFloor(frame.width * 0.99999 - 0.5) - fastFloor(frame.width * 0.01686 + 0.04) + 0.54, height: fastFloor(frame.height * 0.78767) - fastFloor(frame.height * 0.00685))


        //// Glass
        //// Outer Structure Group
        //// Glass Outer Bottom Drawing
        let glassOuterBottomPath = UIBezierPath(ovalIn: CGRect(x: glass.minX + fastFloor(glass.width * 0.00169 + 0.46) + 0.04, y: glass.minY + fastFloor(glass.height * 0.84211 + 0.5), width: fastFloor(glass.width * 0.98118 + 0.46) - fastFloor(glass.width * 0.00169 + 0.46), height: fastFloor(glass.height * 1.00000 + 0.5) - fastFloor(glass.height * 0.84211 + 0.5)))
        UIColor.white.setStroke()
        glassOuterBottomPath.lineWidth = glassOuterBottomWidth
        glassOuterBottomPath.stroke()


        //// Glass Outer Top Drawing
        let glassOuterTopPath = UIBezierPath(ovalIn: CGRect(x: glass.minX + fastFloor(glass.width * 0.00169 + 0.46) + 0.04, y: glass.minY + fastFloor(glass.height * 0.00000 + 0.5), width: fastFloor(glass.width * 0.98118 + 0.46) - fastFloor(glass.width * 0.00169 + 0.46), height: fastFloor(glass.height * 0.15789 + 0.5) - fastFloor(glass.height * 0.00000 + 0.5)))
        UIColor.white.setStroke()
        glassOuterTopPath.lineWidth = glassTopWidth
        glassOuterTopPath.stroke()


        //// Outer Left Edge Drawing
        let outerLeftEdgePath = UIBezierPath()
        outerLeftEdgePath.move(to: CGPoint(x: glass.minX + 0.00000 * glass.width, y: glass.minY + 0.92814 * glass.height))
        outerLeftEdgePath.addLine(to: CGPoint(x: glass.minX + 0.00077 * glass.width, y: glass.minY + 0.08163 * glass.height))
        UIColor.white.setStroke()
        outerLeftEdgePath.lineWidth = lineWidth
        outerLeftEdgePath.stroke()


        //// Outer Right Edge Drawing
        let outerRightEdgePath = UIBezierPath()
        outerRightEdgePath.move(to: CGPoint(x: glass.minX + 0.98286 * glass.width, y: glass.minY + 0.92814 * glass.height))
        outerRightEdgePath.addLine(to: CGPoint(x: glass.minX + 0.98213 * glass.width, y: glass.minY + 0.08211 * glass.height))
        UIColor.white.setStroke()
        outerRightEdgePath.lineWidth = lineWidth
        outerRightEdgePath.stroke()




        //// Inner Structure Group
        //// Glass Inner Bottom Drawing
        let glassInnerBottomPath = UIBezierPath(ovalIn: CGRect(x: glass.minX + fastFloor(glass.width * 0.07703 + 0.46) + 0.04, y: glass.minY + fastFloor(glass.height * 0.80702 + 0.5), width: fastFloor(glass.width * 0.90583 + 0.46) - fastFloor(glass.width * 0.07703 + 0.46), height: fastFloor(glass.height * 0.95614) - fastFloor(glass.height * 0.80702 + 0.5) + 0.5))
        context.saveGState()
        context.setShadow(offset: helpShadowOvalShadow.shadowOffset, blur: helpShadowOvalShadow.shadowBlurRadius, color: (helpShadowOvalShadow.shadowColor as! UIColor).cgColor)
        fluidFillolor.setFill()
        glassInnerBottomPath.fill()
        context.restoreGState()

        context.saveGState()
        context.setShadow(offset: shadow.shadowOffset, blur: shadow.shadowBlurRadius, color: (shadow.shadowColor as! UIColor).cgColor)
        UIColor.white.setStroke()
        glassInnerBottomPath.lineWidth = glassOuterBottomWidth
        glassInnerBottomPath.stroke()
        context.restoreGState()


        //// Inner Left Edge Drawing
        let innerLeftEdgePath = UIBezierPath()
        innerLeftEdgePath.move(to: CGPoint(x: glass.minX + 0.07441 * glass.width, y: glass.minY + 0.88974 * glass.height))
        innerLeftEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.02974 * glass.width, y: glass.minY + 0.49006 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.05569 * glass.width, y: glass.minY + 0.75480 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.04096 * glass.width, y: glass.minY + 0.61470 * glass.height))
        innerLeftEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.00053 * glass.width, y: glass.minY + 0.08761 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.00932 * glass.width, y: glass.minY + 0.26322 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.00053 * glass.width, y: glass.minY + 0.08761 * glass.height))
        UIColor.white.setStroke()
        innerLeftEdgePath.lineWidth = lineWidth
        innerLeftEdgePath.stroke()


        //// Inner Right Edge Drawing
        let innerRightEdgePath = UIBezierPath()
        innerRightEdgePath.move(to: CGPoint(x: glass.minX + 0.90840 * glass.width, y: glass.minY + 0.88923 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.94504 * glass.width, y: glass.minY + 0.57691 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.92821 * glass.width, y: glass.minY + 0.74526 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.93486 * glass.width, y: glass.minY + 0.68934 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.95028 * glass.width, y: glass.minY + 0.51723 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.94679 * glass.width, y: glass.minY + 0.55756 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.94854 * glass.width, y: glass.minY + 0.53765 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.97287 * glass.width, y: glass.minY + 0.22171 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.95831 * glass.width, y: glass.minY + 0.42321 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.96592 * glass.width, y: glass.minY + 0.32246 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.97936 * glass.width, y: glass.minY + 0.12432 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.97530 * glass.width, y: glass.minY + 0.18645 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.97747 * glass.width, y: glass.minY + 0.15370 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.98109 * glass.width, y: glass.minY + 0.09703 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.98002 * glass.width, y: glass.minY + 0.11403 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.98060 * glass.width, y: glass.minY + 0.10490 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.98168 * glass.width, y: glass.minY + 0.08738 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.98138 * glass.width, y: glass.minY + 0.09231 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.98158 * glass.width, y: glass.minY + 0.08906 * glass.height))
        innerRightEdgePath.addLine(to: CGPoint(x: glass.minX + 1.00000 * glass.width, y: glass.minY + 0.08783 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.99940 * glass.width, y: glass.minY + 0.09749 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.99990 * glass.width, y: glass.minY + 0.08951 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.99970 * glass.width, y: glass.minY + 0.09277 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.99767 * glass.width, y: glass.minY + 0.12479 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.99891 * glass.width, y: glass.minY + 0.10537 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.99833 * glass.width, y: glass.minY + 0.11450 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.99118 * glass.width, y: glass.minY + 0.22222 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.99579 * glass.width, y: glass.minY + 0.15419 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.99361 * glass.width, y: glass.minY + 0.18694 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.96858 * glass.width, y: glass.minY + 0.51787 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.98423 * glass.width, y: glass.minY + 0.32301 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.97662 * glass.width, y: glass.minY + 0.42379 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.96333 * glass.width, y: glass.minY + 0.57758 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.96684 * glass.width, y: glass.minY + 0.53829 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.96509 * glass.width, y: glass.minY + 0.55821 * glass.height))
        innerRightEdgePath.addCurve(to: CGPoint(x: glass.minX + 0.92666 * glass.width, y: glass.minY + 0.89024 * glass.height), controlPoint1: CGPoint(x: glass.minX + 0.95315 * glass.width, y: glass.minY + 0.69014 * glass.height), controlPoint2: CGPoint(x: glass.minX + 0.94649 * glass.width, y: glass.minY + 0.74617 * glass.height))
        innerRightEdgePath.addLine(to: CGPoint(x: glass.minX + 0.90840 * glass.width, y: glass.minY + 0.88923 * glass.height))
        innerRightEdgePath.close()
        UIColor.white.setFill()
        innerRightEdgePath.fill()
    }

}
